<?php
session_start();
ini_set('error_reporting', E_ALL);
require('commun.php');
// Logo here
define ('_LOGO', "vespa.png");
// Title here
define ('_ALBUM', "VeSPA");
// Base folder here
define ('_FOLDER', "fotos");
// Colors here (RGB values, between 30 and 225 for each)
define ('_CR', rand(30,75) );
define ('_CG', rand(30,75) );
define ('_CB', rand(30,75) );
// height of the thumbnails
define ('_MINI_HEIGHT', 64 );
// max cached files created by page loaded
define ('_MAX_CACHE', 50 );

switch (substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2)) {
    case 'en':
    default :
	define ('_FS', "FULL SCREEN");
	define ('_RC', "RECURSIVE");
	define ('_AIDE', "HELP");
	define ('_RETOUR', "BACK");
	define ('_PAR', "by");
        break;
    case 'fr':
	define ('_FS', "PLEIN ÉCRAN");
	define ('_RC', "RECURSIF");
	define ('_AIDE', "AIDE");
	define ('_RETOUR', "RETOUR");
	define ('_PAR', "par");
	setlocale(LC_TIME, "fr_FR.UTF-8");
        break;
    case 'pt':
	define ('_FS', "TELA CHEIA");
	define ('_RC', "RECURSIVO");
	define ('_AIDE', "AJUDA");
	define ('_RETOUR', "VOLTAR");
	define ('_PAR', "por");
	setlocale(LC_TIME, "pt_PT.UTF-8");
        break;
}
//////////////////////////////////////////////////////////////////////////////////////
/* ---- Convertit une couleur RGB augmentée de $valeur en HEXADECIMAL ---- */
function hex_color($valeur){
		return sprintf("%02X%02X%02X", _CR+$valeur, _CG+$valeur, _CB+$valeur);
	}

//////////////////////////////////////////////////////////////////////////////////////
/* ---- Lie les dossiers à des URL ---- */
function url_dossier($dossier){
	$tab=explode('/',$dossier);
	$chemin=array_shift($tab);
	$ret='<a href="'.$_SERVER['PHP_SELF'].'">'._ALBUM.'</a>::';
	foreach ( $tab as $url ) {
		$chemin.='/'.$url;
		$ret.="<a href=\"" .$_SERVER['PHP_SELF']. "?dossier=$chemin\">$url</a>::";
	}
	return $ret;
}
//////////////////////////////////////////////////////////////////////////////////////
/* ---- Liste les dossiers d'un dossier ---- */
function show_dossier($dossier,$file_name){
  if (!preg_match("/(.*)\./", $file_name)
  && ( '_gsdata_' != $file_name ) // pour bertrand ;-) 
  && is_dir("$dossier/$file_name") ) {
    $ligne="$dossier/$file_name";
    $dir=opendir("./$ligne");
    $img=''; //pour les dossiers sans images
    while (false !== ($jpg = readdir($dir))) {
	    if (preg_match(_IMAGES_ACCEPTEES, $jpg)) {
		    if (!file_exists("mini/$ligne/$jpg")) {
			    cree_mini("$ligne",$jpg,'mini',_MINI_HEIGHT,0);
		    }
		    $img="<img src=\"mini/$ligne/$jpg\" height=16 alt='$jpg'>";
		    break;
	    }
	    
    }
    
    return "<tr><td align=right>
		    <a href=\"" .$_SERVER['PHP_SELF']. "?dossier=$ligne\">
		    $img</a>
	    </td>
	    <td align=left>
		    <a href=\"" .$_SERVER['PHP_SELF']. "?dossier=$ligne\">
		    $file_name
	    </a></td></tr>";
  }
  else return '';
}
//////////////////////////////////////////////////////////////////////////////////////
/* ---- Affiche les photos et les dossiers d'un dossier ---- */
function show_photos($dossier,$nom,$dossierjoli){
  $mini_existe=0;			// Pas de miniatures par défaut
  $parent = substr_replace($dossier,"",strrpos($dossier,"/"));

  // Recherche d'éventuelles miniatures et de dossiers
  $dir=opendir("./$dossier");
  // Tri alphabétique des fichiers
  while (false !== ($filename = readdir($dir))) $files[] = $filename;
  sort($files);//tri croissant

  
  $echo="";
  // affichage des dossiers en ordre décroissant
  $dossiers=array_reverse($files);
  foreach ($dossiers as $file_name) $echo.=show_dossier($dossier,$file_name);
  closedir($dir);
  if($echo!='') $echo="<table>$echo</table>";


  ## Debut pagination
  if(isset($_GET['page'])) {
    $prev = $_GET['page'] - _MAX_CACHE;
    $next = $_GET['page'] + _MAX_CACHE;
    if($prev>=0) $echo.="<a href='{$_SERVER['PHP_SELF']}?dossier=$dossier&page=$prev'>&#8606; "._MAX_CACHE."</a>";
    if($next<sizeof($files)) $echo.="<a href='{$_SERVER['PHP_SELF']}?dossier=$dossier&page=$next'>"._MAX_CACHE." &#8608; </a>";
    $pagefiles=array_slice($files,$_GET['page'],_MAX_CACHE);
  }
  elseif(sizeof($files)>_MAX_CACHE) {
    $pagefiles=array_slice($files,0,_MAX_CACHE);
    $echo.="<a href='{$_SERVER['PHP_SELF']}?dossier=$dossier&page="._MAX_CACHE."'>"._MAX_CACHE." &#8608;</a>";
  }
  if(!isset($pagefiles)) $pagefiles=$files;
  ## Fin pagination
    
  // Affichage des miniatures
  foreach ($pagefiles as $file_name) {
    $file_url = str_replace("&","ecomercial",$file_name);
    if (preg_match(_IMAGES_ACCEPTEES, $file_name)) {
      if (!file_exists("mini/$dossier/$file_name"))
        cree_mini($dossier,$file_name,'mini',_MINI_HEIGHT,0);
      // Lien spécial si c'est une Vidéo HTML5
      if (file_exists("$dossier/".substr_replace($file_name, 'ogv', strlen($file_name)-3)))
        $file_url=substr_replace($file_url, 'ogv', strlen($file_url)-3);
      elseif (file_exists("$dossier/".substr_replace($file_name, 'mp4', strlen($file_name)-3)))
        $file_url=substr_replace($file_url, 'mp4', strlen($file_url)-3);
      else
        $jpg_existe=1;
      $echo.="<a href=\"" .$_SERVER['PHP_SELF']. "?dossier=$dossier&nom=$file_url\">
		<img src=\"mini/$dossier/$file_name\" alt='$file_name'></a>&nbsp;
                ";
    }
    elseif (preg_match("/(.*)\.(webm)/", $file_name))  {
      $echo.="<br>VIDEO : <a href=\"" .$_SERVER['PHP_SELF']. "?dossier=$dossier&nom=$file_url\">$file_name</a>&nbsp;
	      ";
    }
    elseif (preg_match("/(.*)\.(avi|mpg|mov)/", $file_name))  {
      $echo.="<br>VIDEO : <a href=\"$dossier/$file_name\">$file_name</a><br>
	      ";
    }
  }
  $echo.="</td><td bgcolor=#" .hex_color(-30). " valign =top width=520px>";

  $plein_ecran="<script>
          function rec(){	window.open(\"slideshow.php?dossier=$dossier&recursive=1\",'fs','fullscreen=yes'); }
                  </script>";
  if(isset($jpg_existe) && !isset($_GET['nom'])) $plein_ecran.=" :: <a id='fullscreen'>"._FS." </a>"; else $plein_ecran.=" :: <a href=\"javascript:rec()\">"._FS."</a> :: ";
  $plein_ecran.=" :: <a href=\"javascript:rec()\">"._RC."</a> :: ";
  $debut="
          <td  colspan=2>
                  <table width='100%'>
                          <tr>
                          <td bgcolor=#" .hex_color(15). " align=left valign=center>
                                  $dossierjoli
                          </td>
                          <td bgcolor=#" .hex_color(15). " align=right>
                                  $plein_ecran
                          </td>
                          <td bgcolor=#" .hex_color(15). " align=right>
                                  <a href=help.php>::"._AIDE."::</a>
                          </td>
                          <td bgcolor=#" .hex_color(15). " align=right>
                                  <a href=" .$_SERVER['PHP_SELF']. "?dossier=$parent>
                                  ::"._RETOUR."::</a>
                          </td>
                          </tr>
                  </table>
          </td>
  </tr>
  <tr>
         <td bgcolor=#" .hex_color(-30). " valign=top >
          ";



  if ($nom!="")
  {
          if (preg_match(_IMAGES_ACCEPTEES, $nom))
          {
                  if (!file_exists("cache/$dossier/$nom"))cree_mini($dossier,$nom,'cache',384,1,512);
                  $echo.="
		    <a href='$dossier/$nom'>
		      <img src=\"cache/$dossier/$nom\" alt='$jpg'>
		    </a><br>";
                  $iptc=commentaires($dossier.'/'.str_replace("\'","'",$nom));
                  $echo.= $iptc['commentaire'].$iptc['keyword'];
          }
          else
          {
		  if (preg_match("/(.*)\.(webm)/", $nom)) $mimetype=' type="video/webm" ';
		  if (preg_match("/(.*)\.(mp4)/", $nom)) $mimetype=' type="video/mp4" ';
		  else $mimetype='';
                  $echo.="
		    <video src='/$dossier/$nom' autoplay $mimetype controls='controls'
		       />";
          }
  }
  //////////////////////////////////////////////////////////////////////////////////////
  elseif (isset($jpg_existe))  {
          $echo.= "
                  <div id='galleria'  style='width: 600px; height: 500px;'></div>
		    <script type='text/javascript'>
		      var data = [";
          
          foreach ($files as $file_name) {
                  $ignorer = file_exists("$dossier/".substr_replace($file_name, 'ogv', strlen($file_name)-3));
                  if (!$ignorer && preg_match(_IMAGES_ACCEPTEES, $file_name)) {
                          if (!file_exists("mini/$dossier/$file_name"))cree_mini($dossier,$file_name,'mini',_MINI_HEIGHT,0,0);
                          if (!file_exists("cache/$dossier/$file_name"))cree_mini($dossier,$file_name,'cache',384,1,512);
                          $iptc=commentaires("$dossier/$file_name");
                          $title=str_replace("\n","\\n",$iptc['keyword']);
                          $description=str_replace("\n","\\n",$iptc['commentaire']);
                          $echo.="
                          {
			    thumb: \"mini/$dossier/$file_name\",
			    image: \"cache/$dossier/$file_name\",
			    big: \"$dossier/$file_name\",
			    title: \"$title\",
			    description: \"$description\"
                          },
                          ";
                  }
          }
          $echo=substr($echo,0,-2);
          $echo.= "];

          Galleria.loadTheme('galleria/themes/classic/galleria.classic.min.js');

	  Galleria.run('#galleria', {
	      dataSource: data,
	      autoplay: 3000,
	      carousel: false,
	      thumbnails: false
	  });

          Galleria.ready(function() {
	    var gallery = this;
	    $('#fullscreen').click(function() {
		gallery.toggleFullscreen(); // toggles the fullscreen
		Galleria.configure({
		  transition: 'fade',
		  preload: 3
		});
	    });
	  });

	      
	      
	      </script>";
  }
  //////////////////////////////////////////////////////////////////////////////////////
  $echo.= "</td>";
  echo $debut.$echo;
}
?>
<!DOCTYPE html> 
<html>
<HEAD>
<TITLE>VeSPA</TITLE>
	<meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
	<link REL="shortcut icon" HREF="favicon.png" TYPE="image/x-png">
	<script src="jquery/jquery-1.10.2.min.js" type="text/javascript"></script>
	<script src="galleria/galleria-1.2.9.min.js" type="text/javascript"></script>
	
  <style>
	body {background-color:#000;}
	a {color:#ddd; text-decoration: none; background: none;}
	h3,h4,h5,h6,a:hover,a:active {color:#fff; background: none;}
	#fs a:hover,a.fs:active {color:#fff; background: none;}
	table.center {margin-left:auto; margin-right:auto;}
	img { border: 0; }
  </style>
	
</HEAD>
<body>
 <table border=0>
	<tr>
<?php
//LA BASE ************************************************************************************
if (isset($_GET['dossier']) && is_dir($_GET['dossier']) && $_GET['dossier']!=".")
	$dossier=$_GET['dossier'];
else
	$dossier=_FOLDER;

$dossierjoli=url_dossier($dossier);
$nom="";
// Protection contre les attaques par remontée d'arborescence
$dossier = str_replace("..","",$dossier);
// Merci S4turn pour les caractères spéciaux
if ( isset($_GET['nom']) ) $nom = str_replace(array("ecomercial","\'"),array("&","'"), $_GET['nom']);
show_photos($dossier,$nom,$dossierjoli);
?>
		
	</tr>
</table>
<center><font color=#<?php echo hex_color(30);?> size=-3>

<A href="http://jjorge.free.fr/vespa">VESPA :: VEry Simple Photo Album :: Version 9.5</A>
<?php echo _PAR;?> <a href="mailto:jjorge EM free.fr">José JORGE</a> :: 24 <?php echo strftime('%B',3600*24*330);?> 2014

</font></center></body>
</html>
